/*
 * 20190719-16-9999.c
 *
 *	2 次関数 y = x^2 -54 x + 720 と x 舳が囲む部分の面積
 *
 *	コンパイル :
 *		cc -I ~/c/include -c 20190719-16-9999.c
 *		cc -o 20190719-16-9999.exe 20190719-16-9999.o
 *	実行 :
 *		./20190719-16-9999.exe
 *
 */

#include <stdio.h>

#include "s_print.h"

/*
 * 方程式 x^2 - p x + q = 0 の自然数解を x 〜 mx の範囲で虱潰しで一つ求める
 * 答えが見付かったら、その答え、そうでない場合は -1 を返す
 */

int solve ( int p, int q, int x, int mx ) {

	if ( x > mx ) {			/* もし、答の候補が、大きく成りすぎたら.. */
		/* 答えは見付からなかったので.. -1 を返す */
		return -1;
	} else if ( x * x - p * x + q == 0 ) { /* もし、x が答えなら.. */
		/* 答えを返す */
		return x;
	} else { /* いずれでもなければ、更に、答えを探す (再帰呼出し) */
	  	return solve ( p, q, x + 1, mx );
	}
}

/*
 * 放物線 y = x^2 - 54 x + 720 と x 舳が囲む面積 S は、
 * 方程式 x^2 - 54 x + 720 = 0 の解が a, b (a<b) の時
 * S = ((b-a)^3)/6 で計算される
 */

void area ( int a, int b ) {

	if ( a < 0 ) {		/* 解が負なのは、解が見付からなかった場合なので.. */
		s_print_string ( "面積は、計算できませんでした。\n" );
	} else {
	  	s_print_string ( "面積は " );
		s_print_int ( (b-a)*(b-a)*(b-a)/6 );
	  	s_print_string ( " です。\n" );
	}

}

/*
 * 係数と解の一つを利用して、答えを出力
 *	- p が x の 1 次係数で、a が解の一つならば、解と係数の関係から、
 * もう一つの解は、p - a となるので...
 */

void print_answer ( int p, int a ) {

	/* 解と係数の関係から、もう一つの解は p - a となる */
	area ( a, p - a );
}

/*
 *	main 関数
 */

int main ( void ) {

	/* 方程式 x^2 - 54 x + 720 = 0 の解の小さい方の一つを虱潰しで求め、
	   それを利用して、公式から面積を計算して出力する */

	print_answer ( 54, solve ( 54, 720, 1, 720 ) );

	return 0;
}

