/*
 * 20190719-18-9999.c
 *
 * 次の漸化式の形で定義された数列 { a_n } の第 104 項目を求めなさい。
 *		a_1 = 9
 *		a_{n+1} = (5 * a_{n} + 88) mod 221
 */

#include <stdio.h>
#include <math.h>
#include "s_print.h"
#include "s_input.h"

/*
 * 漸化式に基き、a_n を計算する関数 func(n) を定義する
 */

int func ( int n ) {

	if ( n <= 1 ) {		/* 本当は n == 1 で良いが安全性のため n <= 1 とする */
		/* 初項なので.. */
		return 9;
	} else {			/* n = k + 1 の時は、n = k の値を再帰で求める */
		/* n=k+1 の時、k=n-1 の値を再帰で求める事ができれば */
		/* a_n = a_{k+1} = ( 5 * a_k + 88 ) % 221 = ( 5 * a_{n-1} + 88 ) % 221 */
        /* となるので... */
		return ( 5 * func(n-1) + 88 ) % 221;
	}
}

/*
 *
 */

int main ( int argc, char *argv[] ) {

	s_print_string ( "初項   a_1     = 9\n" );
	s_print_string ( "一般項 a_{n+1} = ( 5 * a_n + 88 ) % 221\n" );
	s_print_string ( "で、定義された数列 {a_n} の第 104 項の値は " );
	s_print_int ( func( 104 ) );
	s_print_string ( " です。\n" );

	return 0;
}

/*
 *
 */

